
function [zupt]=zero_velocity_detector(u,gamma,sigma_a,sigma_g)
zupt=zeros(1,length(u));

T=GLRT(u,sigma_a,sigma_g);
W=12;

for k=1:length(T)
    if T(k)<gamma
       zupt(k:k+W-1)=ones(1,W); 
    end    
end
end

function T=GLRT(u,sigma_a,sigma_g)

g=9.81;
sigma2_a=sigma_a;
sigma2_g=sigma_g;
W=12;


N=length(u);
T=zeros(1,N-W+1);

for k=1:N-W+1
   
    ya_m=mean(u(1:3,k:k+W-1),2);
    
    for l=k:k+W-1
        tmp=u(1:3,l)-g*ya_m/norm(ya_m);
        T(k)=T(k)+u(4:6,l)'*u(4:6,l)/sigma2_g+tmp'*tmp/sigma2_a;    
    end    
end

T=T./W;

end