clear;
lL=-1; %lower bound
uL=1; %upper bound
res=0.001;
x=lL:res:uL;
sigma_SE=1;
l_SE=0.1;
sigma_y=0.2;
y=mvnrnd(0*x,Kern(x,x,sigma_SE,l_SE));
y_min=min(y);

figure(1);
clf;

hold on;
samples=40;
sz=size(x,2);
p=0.2; %proportion used as a margin to avoid samples close to the domain edges
indices=floor(sz*p)+randi(floor(sz*(1-2*p)),samples,1);
x_known=x(indices);
y_known=y(indices)+mvnrnd(zeros(samples,1),sigma_y.^2*eye(samples));



x_star=x;
[y_star, y_star_var]=GaussianProcess(x_known,y_known,x_star,sigma_y,sigma_SE,l_SE);

y_star_min=min(y_star);
variances=sqrt(diag(y_star_var));
plot_min=min(y_min,y_star_min)-max(sqrt(diag(y_star_var)));
plot_max=max(max(y_star),max(y))+max(sqrt(diag(y_star_var)));
H=area(x_star(2:end),y_star(2:end)+variances(2:end),plot_min);
hold on;
A=area(x_star(2:end),y_star(2:end)-variances(2:end),plot_min);
set(H,'FaceColor',[0.9 0.9 0.9]);
H.EdgeColor='none';
A.EdgeColor='none';
hold on;
set(A,'FaceColor',[1 1 1]);
plot(x,y,'b');
plot(x_star,y_star,'k');
scatter(x_known,y_known,'r');
legend({'Plus/minus one standard deviation','','True function','Gaussian process approximation','Known samples'},'Interpreter','Latex');
hold off;
axis off;
axis on;
ylim([plot_min plot_max]);