function [x_red,f_red]=remove_excess_datapoints(x,f,sensitivity)
%This function removes input points that are so
%close in input space that they will cause the kernel
%matrices to be singular. For each point, unless itself has already been
%deleted, delete any point that is too close.
N=size(x,2);
keep_these_points=ones(N,1);
for i=1:N
    if keep_these_points(i)
        for j=i+1:N
            keep_these_points(j)=(keep_these_points(j)&&(norm(x(:,i)-x(:,j))>sensitivity));
        end
    end
end


%Recover only the points you want to keep:
N_red=sum(keep_these_points);
x_red=zeros(size(x,1),N_red);
f_red=zeros(size(f,1),N_red);
k=1;
for i=1:N
   if keep_these_points(i)
       x_red(:,k)=x(:,i);
       f_red(:,k)=f(:,i);
       k=k+1;
   end
end

end