function phi=Phi3D(x,N_m,uL1,lL1,uL2,lL2,uL3,lL3,Indices)
%Basis functions for the SE kernel function
%Call this function first to find indices: [Indices, Lambda]=Lambda2D(m);

j1=Indices(:,1);
j2=Indices(:,2);
j3=Indices(:,3);

N=size(x,2);
phi=zeros(N,N_m);
for i=1:N
    phi(i,:)=1./sqrt(0.5*(uL1-lL1)).*sin(pi*j1'.*(x(1,i)-lL1)./(uL1-lL1))...
           ./sqrt(0.5*(uL2-lL2)).*sin(pi*j2'.*(x(2,i)-lL2)./(uL2-lL2))...
           ./sqrt(0.5*(uL3-lL3)).*sin(pi*j3'.*(x(3,i)-lL3)./(uL3-lL3));
end

end