%The content of this function is a modified version of the "ZUPTaidedINS"
%function with in Isaac Skogs "OpenShoE" software, where functionaliy
%that is not necessary for this project has been removed,
%And variables have been renamed to fit the notation in the report.

function [v,P,P_diag,R,quat,acc_t]=ZUPTEKFDynUpdate(v,P,P_diag,R,quat,acc_t,u,Ts,t,M,Q)

for i=1:M
    
    %Dynamic update of quaternion
    eta=(u(4:6,t))*Ts;
    q_old=quat(:,t-1,i);
    eta1=eta(1);
    eta2=eta(2);
    eta3=eta(3);
    
    OMEGA=zeros(4);
    OMEGA(1,1:4)=0.5*[0 eta3 -eta2 eta1];
    OMEGA(2,1:4)=0.5*[-eta3 0 eta1 eta2];
    OMEGA(3,1:4)=0.5*[eta2 -eta1 0 eta3];
    OMEGA(4,1:4)=0.5*[-eta1 -eta2 -eta3 0];
    
    normeta=norm(eta);
    if normeta~=0
        q_new=(cos(normeta/2)*eye(4)+2/normeta*sin(normeta/2)*OMEGA )*q_old;
        q_new=q_new./norm(q_new); %Normalization because an approximation to the quaternion
        %multiplication is used. If the proper quaternion multiplication
        %was implemented, no normalization would be necessary.
    else
        q_new=q_old;
    end
    
    quat(:,t,i)=q_new;   
    R(:,:,t)=quat2Rot(quat(:,t,i));
    f_t=R(:,:,t)*(u(1:3,t));
    g=[0 0 -9.81]';
    acc_t(:,t-1,i)=f_t+g;
    
    
    F=[eye(3) Sw(f_t)*Ts;
        zeros(3) eye(3)];
    P(:,:,i)=F*P(:,:,i)*F'+Q;
    P(:,:,i)=(P(:,:,i)+P(:,:,i)')/2;
    P_diag(:,t,i)=diag(P(:,:,i));
end

v(:,t,:)=v(:,t-1,:)+Ts.*acc_t(:,t-1,:);

end

%The content of this function is from Isaac Skogs framework OpenShoe
function R=quat2Rot(q)

p=zeros(6,1);

p(1:4)=q.^2;

p(5)=p(2)+p(3);

if p(1)+p(4)+p(5)~=0
    p(6)=2/(p(1)+p(4)+p(5));
else
    p(6)=0;
end


R(1,1)=1-p(6)*p(5);
R(2,2)=1-p(6)*(p(1)+p(3));
R(3,3)=1-p(6)*(p(1)+p(2));

p(1)=p(6)*q(1);
p(2)=p(6)*q(2);
p(5)=p(6)*q(3)*q(4);
p(6)=p(1)*q(2);

R(1,2)=p(6)-p(5);
R(2,1)=p(6)+p(5);

p(5)=p(2)*q(4);
p(6)=p(1)*q(3);

R(1,3)=p(6)+p(5);
R(3,1)=p(6)-p(5);

p(5)=p(1)*q(4);
p(6)=p(2)*q(3);

R(2,3)=p(6)-p(5);
R(3,2)=p(6)+p(5);

end

%The content of this function is from Isaac Skogs framework OpenShoe
function S=Sw(w)
S=[0 -w(3) w(2); w(3) 0 -w(1); -w(2) w(1) 0];
end



