function plot_projection_mag_field_map3D(m,P_m,Indices,uL1,lL1,uL2,lL2,uL3,lL3,z,res,mean_y_m,fontsize)
N_m=size(m,1);
[X1,X2] = meshgrid(lL1:res:uL1,lL2:res:uL2);
length=size(X1,1); width=size(X1,2);
mu=X1;
CoVarMu=X1;
for i=1:length
    for j=1:width
        p_s=[X1(i,j); X2(i,j); z];
        phi_s=Phi3D(p_s,N_m,uL1,lL1,uL2,lL2,uL3,lL3,Indices);
        mu_temp=phi_s*m;
        var=phi_s*P_m*phi_s';
        mu(i,j)=mu_temp;
        CoVarMu(i,j)=var;
    end
end

%Plot the result
Opacity=-CoVarMu;
s1=surf(X1,X2,zeros(size(X1)),mu+mean_y_m,'AlphaData',Opacity,'FaceAlpha','flat');
view(2);
s1.EdgeColor = 'none';
hold on;
hc=colorbar;
caxis([0.5 1.4]);
title(hc,'$\left \| \textbf{H}(\textbf{p}) \right \|$','Interpreter','Latex','Fontsize',fontsize);
xlabel('$x$/[m]','Interpreter','Latex','Fontsize',fontsize);
ylabel('$y$/[m]','Interpreter','Latex','Fontsize',fontsize);
zlabel('$z$/[m]','Interpreter','Latex','Fontsize',fontsize);
xlim([lL1 uL1]);
ylim([lL2 uL2]);
end